﻿Imports System.Windows.Media.Imaging
Partial Public Class Page
 Inherits UserControl
 Dim mBalle As Double = 10, MPendule As Double = 100, V As Double = 400 ' vitesse de la balle en m/s
 Dim bAnimEnCours As Boolean
 Public Sub New()
  InitializeComponent()
 End Sub
 Private Sub animPenduleFin_Completed(ByVal sender As Object, ByVal e As EventArgs)
  bAnimEnCours = False
 End Sub

 Private Sub animPendule_Completed(ByVal sender As Object, ByVal e As EventArgs)
  da1AnimPenduleFin.Value = angle / 2
  da2AnimPenduleFin.Value = -angle / 4
  da3AnimPenduleFin.Value = angle / 8
  da4AnimPenduleFin.Value = 0
  animPenduleFin.Begin()

  ' dessiner angle
  L2.X2 = 415 + 270 * Math.Sin(angleRad)
  L2.Y2 = 215 + 270 * Math.Cos(angleRad)
  afficheAngle.SetValue(Canvas.LeftProperty, CDbl(425 + angle / 90 * 100))
  afficheAngle.Text = angle.ToString("##.#") & "°"

  E3.SetValue(Canvas.LeftProperty, 410 + 240 * Math.Sin(angleRad))
  E3.SetValue(Canvas.TopProperty, 210 + 240 * Math.Cos(angleRad))

  scaleAfficheHauteur.ScaleY = H * 240 / (100 * 100) ' 1 mètre du fil en 240 pixels

  afficheInfo.Opacity = 1
 End Sub
 Private angle, angleRad, H As Double
 Private Sub animBalle_Completed(ByVal sender As Object, ByVal e As EventArgs)
  ' démarrer l'animation du pendule
  ' calculer H
  H = 0.5 / 9.81 * (mBalle / MPendule * V) * (mBalle / MPendule * V)
  ' supposons une longueur de fil d'un mètre (représenté ici en 240 pixels)
  angleRad = Math.Acos((240 - (H * 2.4)) / 240)
  angle = angleRad * 360 / 6.28

  daAnimPendule.To = -angle
  animBalleQuiTombe.Begin()
  animPendule.Begin()
 End Sub

 Private Sub animBalleQuiTombe_Completed(ByVal sender As Object, ByVal e As EventArgs)
  balle.Opacity = 0
  balle.SetValue(Canvas.LeftProperty, 160.0)
  balle.SetValue(Canvas.TopProperty, 450.0)
 End Sub
 Private bCurseurVitesseBalleEnAction As Boolean
 Private PosPrec As Double
 Private Sub vitesseBalleCurseur_MouseLeftButtonUp(ByVal sender As Object, ByVal e As MouseEventArgs)
  bCurseurVitesseBalleEnAction = False
  vitesseBalleCurseur.ReleaseMouseCapture()
 End Sub

 Private Sub vitesseBalleCurseur_MouseLeftButtonDown(ByVal sender As Object, ByVal e As MouseEventArgs)
  bCurseurVitesseBalleEnAction = True
  PosPrec = e.GetPosition(vitesseBalle).X
  vitesseBalleCurseur.CaptureMouse()
 End Sub

 Private Sub vitesseBalleCurseur_MouseMove(ByVal sender As Object, ByVal e As MouseEventArgs)
  If bCurseurVitesseBalleEnAction Then
   Dim X As Double = e.GetPosition(vitesseBalle).X
   X = Math.Max(0, X)
   X = Math.Min(X, 180)
   Dim deltaX As Double = X - PosPrec
   PosPrec = X
   X = CDbl(vitesseBalleCurseur.GetValue(Canvas.LeftProperty))
   vitesseBalleCurseur.SetValue(Canvas.LeftProperty, X + deltaX)
  End If
 End Sub

 Private Sub pistolet_MouseLeftButtonDown(ByVal sender As Object, ByVal e As MouseEventArgs)
  If (Not bAnimEnCours) Then
   bAnimEnCours = True
   afficheInfo.Opacity = 0
   ' animation pour vitesse balle
   Dim X As Double = CDbl(vitesseBalleCurseur.GetValue(Canvas.LeftProperty))
   X = Math.Max(0, X)
   V = 50 + 400 * X / 180 ' vitesse de la balle en m/s
   ' animation pour la balle 
   Dim n As Integer = CInt(Fix(1000 / (V / 50)))
   daScaleXBalle.Duration = New Duration(New TimeSpan(0, 0, 0, 0, n))
   balle.Opacity = 1
   animBalle.Begin()
   ' bruit du pistolet
   bruitPistolet.Stop()
   bruitPistolet.Position = New TimeSpan(0)
   bruitPistolet.Play()
  End If
 End Sub

 Private Sub pistolet_MouseLeave(ByVal sender As Object, ByVal e As EventArgs)
  pistolet.Source = New BitmapImage(New Uri("Pistolet.png", UriKind.Relative))
 End Sub

 Private Sub pistolet_MouseEnter(ByVal sender As Object, ByVal e As MouseEventArgs)
  If (Not bAnimEnCours) Then
   pistolet.Source = New BitmapImage(New Uri("PistoletVert.png", UriKind.Relative))
  End If
 End Sub
End Class